]> git.phdru.name Git - dotfiles.git/blob - .shellrc
Feat(recode-filenames-recursive): Allow to omit parameters
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60
61 OPS1="$OPS1\\$"
62 PS1="$OPS1 "
63
64
65 if test -n "$BASH_VERSION"; then
66    [ "`type -t ls`" = alias ] && unalias ls
67    [ "`type -t ll`" = alias ] && unalias ll
68    [ "`type -t mc`" = alias ] && unalias mc
69
70    back() { cd - "$@"; }
71    functions() { typeset -f "$@"; }
72    j() { jobs; }
73
74    has_completion() { return 0; }
75    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
76       if [ "$SHELL" = /bin/bash ]; then
77          if [ -d /usr/share/bash-completion ]; then
78             . /usr/share/bash-completion/bash_completion
79             has_completion() { [ -r /usr/share/bash-completion/completions/$1 ]; }
80          elif [ -f /etc/bash_completion ]; then
81             . /etc/bash_completion
82             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
83          elif [ -d /etc/bash_completion.d ]; then
84             for _compf in /etc/bash_completion.d/*; do
85                . $_compf
86             done
87             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
88          fi
89       elif [ "$SHELL" = /usr/local/bin/bash ]; then
90          if [ -d /usr/local/etc/bash_completion.d ]; then
91             for _compf in /usr/local/etc/bash_completion.d/*; do
92                . $_compf
93             done
94             has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
95          fi
96       else
97          echo "Unknown OS type, cannot source bash_completion" >&2
98       fi
99    fi
100
101    for cmd in builtin cgmem_nice command dbus-launch exec \
102       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
103       time whence whereis which xargs; do
104          ! has_completion $cmd && complete -o default -A command $cmd
105    done
106
107    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
108       telnet t tt \
109       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
110       whois wget wget-m wget-wrapper ww; do
111          ! has_completion $cmd && complete -A hostname $cmd
112    done
113
114    for cmd in distribute ftp lftp r rsync \
115       s scp ssh smbclient tcpdump tshark wireshark; do
116          ! has_completion $cmd && complete -o default -A hostname $cmd;
117    done
118
119    delegate_completion() {
120       local prog programs
121       prog=$1
122       if has_completion $prog; then
123          shift
124          programs="$@"
125          eval "_${prog}_completion_loader() {
126             _completion_loader $prog
127             complete -F _$prog $programs
128             unset _${prog}_completion_loader
129             return 124
130          }"
131          complete -F _${prog}_completion_loader $programs
132       fi
133    }
134
135    delegate_completion make m
136    delegate_completion ping p
137    delegate_completion rsync r rsync_cgmn rsync_cgmn_recode
138    delegate_completion ssh s
139    delegate_completion wget wget-m wget-wrapper ww
140
141    unset has_completion delegate_completion
142
143    complete -A job bg fg j jobs wait
144    complete -A variable -A function unset
145
146    if [ -d "$HOME/lib/config" ]; then
147       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
148    fi
149    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
150
151    #if type -p pip >/dev/null 2>&1; then
152    #   eval "`pip completion --bash`"
153    #   rm -rf /tmp/pip_build_"$USER"
154    #fi
155
156    #if which pyenv >/dev/null 2>&1; then
157    #   eval "`pyenv init -`"
158    #   eval "`pyenv virtualenv-init -`"
159    #fi
160
161    source virtualenvwrapper_lazy.sh 2>/dev/null
162
163    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
164       . "$VIRTUAL_ENV/bin/activate"
165    fi
166
167    # Clean up python virtual environment on exit
168    # See https://virtualenvwrapper.readthedocs.io/en/latest/tips.html#clean-up-environments-on-exit
169
170    trap '[ "$VIRTUAL_ENV" ] && deactivate' EXIT
171
172 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
173    back() { cd - "$@"; }
174    j() { jobs; }
175 fi
176
177
178 # clear screen and history, logout
179 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
180
181
182 if test -x /usr/bin/git >/dev/null 2>&1; then
183    # chdir to a directory
184    cdgitpath() {
185       if [ -z "$1" -o -n "$2" ]; then
186          echo "Usage: cdgitpath path_key" >&2
187          return 1
188       else
189          path_key="$1"
190       fi
191
192       if [ -z "$path_key" ]; then
193          echo "Usage: cdgitpath path_key" >&2
194          return 1
195       fi
196
197       cd "`git config --get --path $path_key`"
198    }
199
200    # chdir to a remote's directory (if the remote is on the local FS)
201    cdremote() {
202       if [ -z "$1" ]; then
203          branch="`git rev-parse --abbrev-ref HEAD`"
204          remote="`git config --get branch.$branch.remote`"
205       elif [ -n "$2" ]; then
206          echo "Usage: cdremote [remote_name]" >&2
207          return 1
208       else
209          remote="$1"
210       fi
211
212       if [ -z "$remote" ]; then
213          echo "Cannot find remote for branch $branch" >&2
214          echo "Usage: cdremote [remote_name]" >&2
215          return 1
216       fi
217
218       cdgitpath remote.$remote.url
219    }
220
221    if test -n "$BASH_VERSION"; then
222       # completion for aliases in global .gitconfig
223
224       # fixup rbi rbia rbiap rbip - do refs name completion
225       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
226       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
227       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
228       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
229       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
230       #
231       # push-to-all-remotes - do branch name completion
232       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
233
234       _cdgitpath_completion_loader() {
235          _completion_loader git
236          complete -F _cdgitpath_complete cdgitpath git-open
237          unset _cdgitpath_completion_loader
238          return 124
239       }
240
241       _cdgitpath_complete() {
242          local cword="${COMP_CWORD}" cur="${COMP_WORDS[COMP_CWORD]}";
243          COMPREPLY=(`compgen -W "$(__git_config_get_set_variables)" -- "$cur"`)
244       }
245
246       _git_open() {
247          _cdgitpath_complete
248       }
249
250       complete -F _cdgitpath_completion_loader cdgitpath git-open
251
252       # list remotes with URLs matching a regexp
253       _list_remotes() {
254          if [ -z "$1" -o -n "$2" ]; then
255             echo "Usage: _list_remotes remote_regexp" >&2
256             return 1
257          fi
258          GIT_REMOTES=""
259          local remote
260          for remote in `git remote`; do
261             if git config --get remote.$remote.url | grep -q "$1"; then
262                GIT_REMOTES="$GIT_REMOTES $remote"
263             fi
264          done
265       }
266
267       # completion for cdremote and git-open-remote - list remotes with a pattern
268       _list_remotes_completion() {
269          local cur="${COMP_WORDS[COMP_CWORD]}";
270          _list_remotes "$1"
271          COMPREPLY=(`compgen -W "$GIT_REMOTES" -- "$cur"`)
272          unset GIT_REMOTES
273       }
274
275       # completion for cdremote - list remotes with directories as URLs
276       _cdremote_complete() {
277          _list_remotes_completion '^\(/\|\.\./\)' # (/ or ../ at the beginning)
278          if [ ${#COMPREPLY[*]} -eq 0 ]; then
279             _list_remotes_completion .
280          fi
281       }
282
283       complete -F _cdremote_complete cdremote
284
285       # completion for git-open-remote - list remotes with http(s) URLs
286       _git_open_remote() {
287          _list_remotes_completion '^http\(s\)\?://'
288          if [ ${#COMPREPLY[*]} -eq 0 ]; then
289             _list_remotes_completion .
290          fi
291       }
292
293       complete -F _git_open_remote git-open-remote
294    fi
295 fi
296
297
298 include() {
299    cfg="$1"
300    if [ -f "./$cfg" -a -r "./$cfg" ]; then
301       echo "Reading config file \`$cfg'" 1>&2
302       . "./$cfg"
303    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
304       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
305       . "$HOME/lib/config/$cfg"
306    else
307       echo "Cannot find config file \`$cfg'" 1>&2
308    fi
309 }
310
311
312 mc() {
313    if test -n "$BASH_VERSION"; then
314       MC_SAVE_OPS1="$OPS1"
315       OPS1="\u@\h "
316    fi
317
318    if [ -n "$SLOWTERM" ]; then
319       MC_SLOW="--slow"
320    fi
321
322    case "$TERM" in
323       screen*) # screen, screen.rxvt
324          if [ "$TERM" = screen.rxvt ]; then
325             MC_SAVE_TERM="$TERM"
326             TERM=rxvt
327          fi
328          MC_XTERM="-x"
329       ;;
330    esac
331
332    #TMPDIR="$HOME"/tmp
333    #export TMPDIR
334
335    MC_FOUND=NO
336
337    for wrapper in \
338          /usr/local/share/mc/bin/mc-wrapper.sh \
339          /usr/local/libexec/mc/mc-wrapper.sh \
340          /usr/share/mc/bin/mc-wrapper.sh; do
341       if [ -r $wrapper ]; then
342          . $wrapper $MC_SLOW $MC_XTERM "$@"
343          rc=$?
344          MC_FOUND=YES
345          break
346       fi
347    done
348
349    if [ $MC_FOUND = NO ]; then
350       for mc in /usr/local/bin/mc /usr/bin/mc; do
351          if [ -x $mc ]; then
352             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
353             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
354                MC_TMP_DIR="${TMPDIR-/tmp}"
355             fi
356             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
357             mc_type="`mc_type.py $mc`"
358             if [ "$mc_type" = old ]; then
359                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
360             elif [ "$mc_type" = new ]; then
361                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
362             else
363                continue
364             fi
365             rc=$?
366             MC_FOUND=YES
367             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
368             break
369          fi
370       done
371    fi
372
373    if [ $MC_FOUND = NO ]; then
374       echo "Cannot find mc-wrapper.sh or mc" >&2
375       rc=1
376    fi
377
378    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
379    [ -n "$MC_SAVE_TERM" ] && TERM="$MC_SAVE_TERM"
380    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SAVE_TERM \
381          MC_SLOW MC_TMP_DIR MC_XTERM
382
383    return $rc
384 }
385
386
387 mkcd() {
388    if [ $# -ne 1 ]; then
389       echo "Usage: mkcd directory_name" >&2
390    elif [ -d "$1" ]; then
391       cd "$1"
392    elif [ -e "$1" ]; then
393       echo "Error: $1 is a file" >&2
394    else
395       mkdir -p "$1" && cd "$1"
396    fi
397 }
398
399
400 if which tmux >/dev/null 2>&1; then
401    tmux() {
402       case "$TERM" in
403          rxvt)
404             TERM=rxvt-unicode command tmux "$@"
405          ;;
406
407          *)
408             command tmux "$@"
409          ;;
410       esac
411    }
412 fi
413
414
415 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
416    X() { startx >> .Xserver.log 2>&1; cyr; rm -f .Xauthority; }
417 fi
418
419 x() { exit; }